package com.unissoft.mqtt;

import lombok.extern.slf4j.Slf4j;
import org.springframework.util.LinkedMultiValueMap;
import org.springframework.util.MultiValueMap;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.client.RestTemplate;

import javax.annotation.Resource;
import java.util.Date;

/**
 * @author qingsong.han
 * @description: mqtt test send message
 * @create 2022-10-11 17:47
 */
@Slf4j
@RestController
public class MqttTestSendController {
    @Resource
    private RestTemplate restTemplate;

    @GetMapping("/mqttSendMsg")
    public String sendMessage() {
        MultiValueMap<String, Object> requestEntity = new LinkedMultiValueMap<>();
        // DS-2CD7T27DWD-IZS(16384)/DS-7716NX-I4(4354)
        requestEntity.add("sAlarmType", 4354);
        requestEntity.add("alarmNow", new Date());
        restTemplate.postForObject("http://localhost:8072/pushIntrusion", requestEntity, Object.class);
        return "200";
    }

}
