package com.unissoft.utils;

import org.springframework.beans.BeansException;
import org.springframework.context.ApplicationContext;
import org.springframework.context.ApplicationContextAware;
import org.springframework.stereotype.Component;
import reactor.util.annotation.Nullable;

/**
 * @author qingsong.han
 * @description: 多线程获取bean
 * @create 2022-10-14 15:12
 */
@Component
public class GetBeanUtil implements ApplicationContextAware {
    // get bean static constant
    private static ApplicationContext applicationContext;

    @Override
    public void setApplicationContext(@Nullable ApplicationContext context) throws BeansException {
        GetBeanUtil.applicationContext = context;
    }

    public static Object getBean(String name) {
        return applicationContext.getBean(name);
    }

    public static ApplicationContext getApplicationContext() {
        return applicationContext;
    }

}
